package com.diagbot.repository;

import com.diagbot.dto.DrugBillNeoDTO;
import com.diagbot.dto.RangeNeoDTO;
import com.diagbot.entity.node.*;

import java.math.BigDecimal;
import java.util.Set;

public class MedicineNode {


    public DrugBillNeoDTO MedicinetoDrugDTO(Medicine medicine) {
        DrugBillNeoDTO drugBillNeoDTO = new DrugBillNeoDTO();

        Age age = medicine.getAge();
        if (age!=null) {
            RangeNeoDTO ageNeoDTO = new RangeNeoDTO();
            ageNeoDTO.setMin(BigDecimal.valueOf(age.getMinval()));
            ageNeoDTO.setMax(BigDecimal.valueOf(age.getMaxval()));
            drugBillNeoDTO.setAgeNeoDTO(ageNeoDTO);
        }


        Gender gender = medicine.getGender();
        String gender_val = (gender==null)?"":gender.getName();
        drugBillNeoDTO.setGender(gender_val);


        Set<ClinicalFinding> clinicalfindings = medicine.getClinicalfindings();
        for (ClinicalFinding clinicalfinding : clinicalfindings) {
            RangeNeoDTO rangeNeoDTO = new RangeNeoDTO();
            String clinicalfinding_val = (clinicalfinding==null)?"":clinicalfinding.getName();
            rangeNeoDTO.setName(clinicalfinding_val);

            if (clinicalfinding.getUnit()!=null) {
                rangeNeoDTO.setUnit(clinicalfinding.getUnit());
                if (null!=clinicalfinding.getMinval()) {
                    rangeNeoDTO.setMin(new BigDecimal(clinicalfinding.getMinval()));
                }
                if (null!=clinicalfinding.getMaxval()) {
                    rangeNeoDTO.setMax(new BigDecimal(clinicalfinding.getMaxval()));
                }
            }
            drugBillNeoDTO.getClinicfindings().add(rangeNeoDTO);
        }


        Set<LIS> lisset = medicine.getLisset();
        for (LIS lis : lisset) {
            RangeNeoDTO rangeNeoDTO = new RangeNeoDTO();
            String lis_val = (lis==null)?"":lis.getName();
            rangeNeoDTO.setName(lis_val);

            if (lis.getUnit()!=null) {
                rangeNeoDTO.setUnit(lis.getUnit());
                if (null!=lis.getMinval()) {
                    rangeNeoDTO.setMin(new BigDecimal(lis.getMinval()));
                }
                if (null!=lis.getMaxval()) {
                    rangeNeoDTO.setMax(new BigDecimal(lis.getMaxval()));
                }
            }

            drugBillNeoDTO.getLis().add(rangeNeoDTO);
        }


        Set<PACS> pacsset = medicine.getPacs();
        for (PACS pacs : pacsset) {
            RangeNeoDTO rangeNeoDTO = new RangeNeoDTO();
            String pacs_val = (pacs==null)?"":pacs.getName();
            rangeNeoDTO.setName(pacs_val);

            if (pacs.getUnit()!=null) {
                rangeNeoDTO.setUnit(pacs.getUnit());
                if (null!=pacs.getMinval()) {
                    rangeNeoDTO.setMin(new BigDecimal(pacs.getMinval()));
                }
                if (null!=pacs.getMaxval()) {
                    rangeNeoDTO.setMax(new BigDecimal(pacs.getMaxval()));
                }
            }

            drugBillNeoDTO.getPacs().add(rangeNeoDTO);
        }


        Set<AllergicMed> allergicmeds = medicine.getAllergicmeds();
        for (AllergicMed allergicmed: allergicmeds) {
            String allergicmed_val = (allergicmed == null) ? "" : allergicmed.getName();
            drugBillNeoDTO.getAllergicmeds().add(allergicmed_val);
        }


        Set<Operation> operations = medicine.getOperations();
        for (Operation operation : operations) {
            String operation_val = (operation == null) ? "" : operation.getName();
            drugBillNeoDTO.getOperations().add(operation_val);
        }


        Set<Procedure> procedures = medicine.getProcedures();
        for (Procedure procedure : procedures) {
            String procedure_val = (procedure == null) ? "" : procedure.getName();
            drugBillNeoDTO.getProcedures().add(procedure_val);
        }


        Set<Disease> diseases = medicine.getDiseases();
        for (Disease disease : diseases) {
            String disease_val = (disease == null) ? "" : disease.getName();
            drugBillNeoDTO.getDisease().add(disease_val);
        }


        Set<Group> groups = medicine.getGroups();
        for (Group group : groups) {
            String group_val = (group == null) ? "" : group.getName();
            drugBillNeoDTO.getGroup().add(group_val);
        }


        Set<ConflictMed> conflictmeds = medicine.getConflictmeds();
        for (ConflictMed conflictMed : conflictmeds) {
            String conflict_val = (conflictMed == null) ? "" : conflictMed.getName();
            drugBillNeoDTO.getConflictmeds().add(conflict_val);
        }


        return drugBillNeoDTO;
    }
}

